/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-url-data-model.html
 */

/// <reference path="../polymer/types/polymer-element.d.ts" />
/// <reference path="../polymer/types/lib/elements/dom-if.d.ts" />
/// <reference path="../raml-aware/raml-aware.d.ts" />
/// <reference path="../api-view-model-transformer/api-view-model-transformer.d.ts" />
/// <reference path="../amf-helper-mixin/amf-helper-mixin.d.ts" />

declare namespace ApiElements {

  /**
   * `api-url-data-model`
   * An element to generate view model for api-url-editor and api-url-params-editor
   * elements from AMF model
   */
  class ApiUrlDataModel extends
    ApiElements.AmfHelperMixin(
    Polymer.Element) {

    /**
     * Name of the scope to use with `raml-aware`.
     * If this element is used with other aware elements, it updates
     * `webApi` when aware value change.
     */
    aware: string|null|undefined;

    /**
     * Computed value of WebApi amf shape.
     */
    readonly _webApi: object|null|undefined;

    /**
     * Computed value pof server definition from the AMF model.
     */
    readonly _server: object|null|undefined;

    /**
     * List of supported protocols.
     * Required to compute base URI in some cases.
     */
    readonly _protocols: object|null|undefined;

    /**
     * API version name
     */
    readonly version: string|null|undefined;

    /**
     * A promise that always results to API's (server's) URI (path)
     * variables model.
     */
    readonly _apiUriParams: Promise<any[]|null|undefined>;

    /**
     * A promise that always results to combined list of server's and
     * selected endpoint URI (path) variables model.
     */
    readonly _pathUriParams: Promise<any[]|null|undefined>;

    /**
     * A promise that always results to selected method query
     * parameters model. It may return `undefined` if selected is not
     * `supportedOperation` shape.
     */
    readonly _methodQueryParams: Promise<any[]|null|undefined>;

    /**
     * Computed value of endpoint from `selected` property.
     * It is the same if selected is an endpoint. It matters when selected
     * is method (supported operation)
     */
    readonly _endpointId: string|null|undefined;

    /**
     * The `@id` property of selected endpoint and method to compute
     * data models for.
     */
    selected: string|null|undefined;

    /**
     * Computed model of selected endpoint
     */
    readonly endpoint: object|null|undefined;

    /**
     * Computed value if `selected` is a `supportedOperation`
     * schape.
     */
    readonly isMethod: boolean|null|undefined;

    /**
     * Computed model of HTTP method.
     */
    readonly method: object|null|undefined;

    /**
     * Computed view model for API uri parameters.
     */
    readonly apiParameters: any[]|null|undefined;

    /**
     * A property to set to override AMF's model base URI information.
     * When this property is set, the `endpointUri` property is recalculated.
     */
    baseUri: string|null|undefined;

    /**
     * Computed value of API base URI.
     */
    readonly apiBaseUri: string|null|undefined;

    /**
     * Generated view model for query parameters.
     */
    readonly queryModel: any[]|null|undefined;

    /**
     * Generated view model for path parameters
     */
    readonly pathModel: object|null;

    /**
     * Computed value of full endpoint URI when selection has been made.
     */
    readonly endpointUri: string|null|undefined;

    /**
     * Selected endponit relative path.
     */
    readonly endpointPath: string|null|undefined;

    /**
     * Computes endpoint full URI by combining `apiBaseUri` with `path`.
     *
     * @param apiBaseUri Current value of `apiBaseUri`
     * @param path Endpoint's path
     * @returns Endpoint's full uri.
     */
    _computeEndpointUri(apiBaseUri: String|null, path: String|null): String|null;

    /**
     * Computes version of the API.
     *
     * @param api http://schema.org/WebAPI declaration
     * @returns API version
     */
    _commputeApiVersion(api: object|null): String|null|undefined;

    /**
     * Computes `apiBaseUri` property when `amfModel` change.
     *
     * @param version API version number
     * @param protocols List of supported protocols.
     * @param baseUri A uri to override APIs base uri
     */
    _computeApiBaseUri(server: any, version: String|null, protocols: Array<String|null>|null, baseUri: String|null): any;

    /**
     * Computes uri paramerters lsit for API base.
     * If `version` is set it eliminates it from the variables if it's set.
     *
     * @param server The `http://raml.org/vocabularies/http#server`
     * object
     * @param version API version number
     * @returns Promise resolved to a view model.
     */
    _computeApiUriParams(server: object|null, version: String|null): Promise<Array<object|null>|null>;
    _computePathUriParams(endpoint: any): any;
    _computeMethodQueryParams(method: any): any;
    _computeEndpointPath(endpoint: any): any;
    _computeMethod(isMethod: any, selected: any, endpoint: any): any;

    /**
     * Computes endpoint `@id` for given `id`.
     * On a base level it subrtacts the last part after `/` which
     * is a delimiter between endpoint identifier and method name.
     *
     * @param id Object ID. Can be operation's or endpoint's ID.
     * @returns Endpoint id. It may return the same value if passed
     * id is endpoint ID.
     */
    _computeEndpointId(id: String|null): String|null;

    /**
     * Finds a method definition on the list of operations for an endpoint.
     *
     * @param id ID of the operation (method)
     * @param operations List of endpoint's operations.
     * @returns Method definition.
     */
    findMethod(id: String|null, operations: Array<object|null>|null): object|null|undefined;
    _computeIsMethod(selected: any, _endpointId: any): any;

    /**
     * Produces view model for query parameters.
     *
     * @param method Method definition in the endpoint model.
     */
    _setupQueryViewModel(method: object|null): Promise<any>|null;
    _setApiParametersPromise(promise: any): void;
    _setPathModelPromise(promise: any): void;
    _setQueryModelPromise(promise: any): void;
  }
}

interface HTMLElementTagNameMap {
  "api-url-data-model": ApiElements.ApiUrlDataModel;
}
